// Copyright (c) 1997 Andrew Maltsev <am@amsoft.ru>
// All rights reserved
// 
// Standart create, finish and error reporting functions for any
// driver. It is highly recommended to include this file into every
// driver and to place any initialization/destruction code into DS(data)
// constructor/destructor.
//
// If you need to initialize something on per file, not per instance
// basis - use static data members, not global variables!
//
// $Id: DrvStd.h,v 1.2 1997/09/20 19:05:32 am Exp $
//

///////////////////////////////////////////////////////////////////////////////
// Creating driver instance data
//
DS(data) *
DS(create) ()
{ DS(data) *data=new DS(data);
  if(!data)
   { log(D_ERROR|D_IDRV,"Cannot create an instance of data for `%s' driver",DriverName);
     return NULL;
   }
  return data;
}

///////////////////////////////////////////////////////////////////////////////
// Finishing driver instance. After returning `data' is unusable!
//
bool
DS(finish) (DS(data) *data)
{ if(!data)
   { log(D_ERROR|D_IDRV,"Finishing non-created object for `%s' driver",DriverName);
     return false;
   }
  delete data;
  return true;
}

///////////////////////////////////////////////////////////////////////////////
// Error reporting. Just an interface to driver's internal
// easysql_error_reporting based data class.
//
char const *
DS(error) (DS(data) *data)
{ return data->error_text();
}

///////////////////////////////////////////////////////////////////////////////
// Cleaning error text. It is suitable to have such an interface to
// free driver's implementer from having to call data->no_error() in
// the beginning of every function - this functionality moved to
// easysql_driver_shell.
//
void
DS(no_error) (DS(data) *data)
{ data->no_error();
}
